#include "emmintrin.h"
#include "nmmintrin.h"

unsigned int bit_count_sse42_x32(int *block, int *block_end)
{
	unsigned int sum;
	sum = 0;
	while (block < block_end)
	{
		int b = *block;
		sum = sum + _mm_popcnt_u32(b);
		block++;
    }
	return sum;
}
/*
unsigned int bit_count_sse42_x64(__int64 *block, __int64 *block_end)
{
	unsigned int sum;
	sum = 0;
	while (block < block_end)
	{
		__int64 b = *block;
		sum = sum + _mm_popcnt_u64(b);
		block++;
    }
	return sum;
}
*/