//#include "stdafx.h"

unsigned int bit_count_x86(unsigned int *block, unsigned int* block_end)
{
	unsigned int b, sum;
	sum = 0;
	while (block < block_end)
	{
		b = *block;
		b = (b & 0x55555555) + (b >> 1 & 0x55555555);
		b = (b & 0x33333333) + (b >> 2 & 0x33333333);
		b = (b + (b >> 4)) & 0x0F0F0F0F;
		b = b + (b >> 8);
		b = (b + (b >> 16)) & 0x0000003F;
		sum = sum + b;
		block++;
    }
	return sum;

}

unsigned int bit_count_x86_m(unsigned int *block, unsigned int* block_end)
{
	unsigned int i, sum, tmp1;
	sum = 0;
	while (block < block_end)
	{
		i = *block;
		i = i - ((i >> 1) & 0x55555555);
		i = (i & 0x33333333) + ((i >> 2) & 0x33333333);
		i = (i + (i >> 4)) & 0x0f0f0f0f;		
		i = (i * 0x1010101) >> 24;

		sum = sum + i;
		block++;
	}
	return sum;
}
